function Api() as Object
	return {
	    API_KEY: "TUxrbTF1NWRNWGoxdnQ4V1htWHFWcTRYTC93d1puQVhYS1VYcmhxUnBaTEk0UDRKZnpsTWh5QzQ0dElwTWxUZE5td1hBd0ZzQ3JqeVB3RVRDVjUrVjNacE1JYTlKRTJDSGo3NHNSSTUxaFE9"
		SLASH: "/"

		'default email address
		DEFAULT_EMAIL: "default@sageiptv.com"

		'API TAGs
		FROM_PLATFORM : "Roku"
		CHECK_LOGIN_TAG: "/checkLogin"
		REGISTRATION_TAG: "/apiRegisterUser"
		DEVICE_REGISTER_TAG: "/checkSubscription"
		PURCHASE_VERIFIATION_TAG: "/subscribeUserByEmail"
		HOME_CONTENT_TAG: "/categories"
		VIDEO_CONTENT_TAG: "/channels"
		GET_MANAGE_LISTS_TAG: "/apilists/view"
		ADD_NEW_LIST_TAG: "/apilists/add"
		UPDATE_LIST_TAG: "/apilists/edit"
		REFRESH_LIST_TAG: "/apilists/refresh"
		DELETE_LIST_TAG: "/apilists/delete"
		SEARCH_TAG: "/search"
		ADD_TO_FAVORITES: "/addToFavorites"
		REMOVE_FROM_FAVORITES: "/removeFromFavorites"
		CHECK_FAVORITE_CHANNEL: "/checkIfChannelIsInFavorites"
		CHECK_SHARED_ACCOUNT: "/isSharedAccount"
		GENERATE_CODE: "/generateCode"
        DEEP_LINK: "/deeplinking"
        IS_ACTIVATED: "/isActivated"
        IS_REGISTERED: "/isRegistered"

		'Registration API
		apiUserRegistration: sub(request as Object)
		    params = request.params
            baseURL = params.baseURL
            email = params.email
            password = params.password

            info = CreateObject("roDeviceInfo")
            deviceId = info.GetChannelClientId()
            url = baseURL + m.REGISTRATION_TAG + m.SLASH + email + m.SLASH + password + m.SLASH + m.API_KEY + m.SLASH + m.FROM_PLATFORM 

            builder = RequestBuilder(url)
            ret = getJson(builder)

            registration = ret.registration
            token = ret.token
            if registration <> Invalid
                request.result = {status: registration, token: token}
            else
                request.result = {status: "failed"}
            End If
		end sub

		'API check login status
		checkLogin: sub(request as Object)
			params = request.params
			baseURL = params.baseURL
			email = params.email
			password = params.password

			info = CreateObject("roDeviceInfo")
            deviceId = info.GetChannelClientId()

			url = baseURL + m.CHECK_LOGIN_TAG + m.SLASH + email + m.SLASH + password + m.SLASH + m.API_KEY

			builder = RequestBuilder(url)
			ret = getJson(builder)

			if ret["logged_in"] <> Invalid
                request.result = {"status": ret["logged_in"] = "true", token: ret.token}
            else
                request.result = {"status": false}
            End If
	    end sub

	    'API get subscription status
	    getSubscription: sub(request as Object)
	        params = request.params
            baseURL = params.baseURL
            email = params.email

            url = baseURL + m.DEVICE_REGISTER_TAG + m.SLASH + email + m.SLASH +  m.API_KEY

            builder = RequestBuilder(url)
            ret = getJson(builder)
            ? "ret >>>>>>>>>>>>> ";ret
            if ret["error"] <> Invalid  Then
                request.result = {"status": false}
            Else if ret["expired"] <> Invalid
                request.result = {"status": (NOT ret["expired"])}
            Else
                request.result = {status: false}
            End If
	    end sub

	    'API to save subscription
	    saveSubscription: sub(request as Object)
	       params = request.params

           baseURL = params.baseURL
           purchaseID = params.purchaseId
           email = params.email
           url = baseURL + m.PURCHASE_VERIFIATION_TAG + m.SLASH + email + m.SLASH +  m.API_KEY + m.SLASH + purchaseID
           builder = RequestBuilder(url)
           ret = getJson(builder)
           request.result = {"response": ret}
	    end sub

	    'API to get Home content
	    getHomeContent: sub(request as Object)
	       params = request.params
	       baseURL = params.baseURL
	       email = params.email

           url = baseURL + m.HOME_CONTENT_TAG + m.SLASH + email + m.SLASH + m.API_KEY
           builder = RequestBuilder(url)
           response = getJson(builder)

           request.result = parseHomeContent(response)
	    end sub

	    'API to get Video content
	    getVideoContent: sub(request)
	       params = request.params

	       baseURL = params.baseURL
           email = params.email
	       videoId = params.videoId

	       url = baseURL + m.VIDEO_CONTENT_TAG + m.SLASH + email +  m.SLASH + m.API_KEY + m.SLASH + videoId
	       builder = RequestBuilder(url)
           response = getJson(builder)
           request.result = getVideoContents(response)
	    end sub

	    'get manage lists
	    getManageLists: sub(request)
	       params = request.params

           baseURL = params.baseURL
           email = params.email
           url = baseURL + m.GET_MANAGE_LISTS_TAG + m.SLASH + email +  m.SLASH + m.API_KEY

           builder = RequestBuilder(url)
           response = getJson(builder)

           if response = invalid OR response.count() = 0 OR response.lists = invalid OR response.lists.count() = 0
               request.result = { content: invalid }
               return
           end if

           request.result = parseManageLists(response)
	    end sub

	    'add new list
	    addNewList: sub(request)
	       params = request.params

           baseURL = params.baseURL
           email = params.email
           label = params.label
           encodedURL = params.encodedurl

	       url = baseURL + m.ADD_NEW_LIST_TAG + m.SLASH + email +  m.SLASH + m.API_KEY +  m.SLASH + label + "?url=" + encodedURL
           builder = RequestBuilder(url)
           response = getJson(builder)
           request.result = {}
	    end sub

	    'update list
        updateList: sub(request)
           params = request.params

           baseURL = params.baseURL
           email = params.email
           label = params.label
           id = params.id
           encodedURL = params.encodedurl

           url = baseURL + m.UPDATE_LIST_TAG + m.SLASH + email +  m.SLASH + m.API_KEY +  m.SLASH + id + m.SLASH + label + "?url=" + encodedURL
           builder = RequestBuilder(url)
           response = getJson(builder)
           request.result = {}
        end sub
        
        'refresh playlist
        refreshList: sub(request)
           params = request.params
           baseURL = params.baseURL
           email = params.email
           id = params.id
           url = baseURL + m.REFRESH_LIST_TAG + m.SLASH + email +  m.SLASH + m.API_KEY +  m.SLASH + id
           builder = RequestBuilder(url)
           response = getJson(builder)
           request.result = {}
        end sub

        'delete list
        deleteList: sub(request)
           params = request.params

           baseURL = params.baseURL
           email = params.email
           id = params.id

           url = baseURL + m.DELETE_LIST_TAG + m.SLASH + email +  m.SLASH + m.API_KEY +  m.SLASH + id
           builder = RequestBuilder(url)
           response = getJson(builder)
           request.result = {}
        end sub

        'Search API
        search: sub(request)
            params = request.params
            baseURL = params.baseURL
            email = params.email
            keyword = params.keyword.escape()

            if (len(keyword) = 0)
                request.result = {result: invalid}
                return
            end if

            url = baseURL + m.SEARCH_TAG + m.SLASH + email + m.SLASH + m.API_KEY + m.SLASH + keyword
            builder = RequestBuilder(url)
            response = getJson(builder)

            request.result = { content: parseSearchResponse(response) }
        end sub

        'add favorite channel api
        addFavourite: sub(request)
            params = request.params
            baseURL = params.baseURL
            email = params.email
            channelID = params.channelID
            url = baseURL + m.ADD_TO_FAVORITES + m.SLASH + email + m.SLASH + m.API_KEY + m.SLASH + channelID.Escape()
            builder = RequestBuilder(url)
            response = getJson(builder)

            request.result = response
        end sub

        'remove channel from favorite channel api
        removeFromFavorites: sub(request)
            params = request.params
            baseURL = params.baseURL
            email = params.email
            channelID = params.channelID
            url = baseURL + m.REMOVE_FROM_FAVORITES + m.SLASH + email + m.SLASH + m.API_KEY + m.SLASH + channelID.Escape()
            builder = RequestBuilder(url)
            response = getJson(builder)

            request.result = response
        end sub

        'check if channel is in favorites
        checkChannelInFavorites: sub(request)
            params = request.params
            baseURL = params.baseURL
            email = params.email
            channelID = params.channelID
            url = baseURL + m.CHECK_FAVORITE_CHANNEL + m.SLASH + email + m.SLASH + m.API_KEY + m.SLASH + channelID.Escape()
            builder = RequestBuilder(url)
            response = getJson(builder)

            request.result = response
        end sub

        'check if the current account is shared account
        'response: shared_account true/false
        isShareAccount: sub(request)
            params = request.params
            baseURL = params.baseURL
            email = params.email

            url = baseURL + m.CHECK_SHARED_ACCOUNT + m.SLASH + email + m.SLASH + m.API_KEY

            builder = RequestBuilder(url)
            response = getJson(builder)

            request.result = response
        end sub
        deepLink: sub(request)
            params = request.params
            baseURL = params.baseURL
            email = params.email
            channelID = param.channelID

            url = baseURL + m.DEEP_LINK + m.SLASH + email + m.SLASH + m.API_KEY + m.SLASH + channelID

            builder = RequestBuilder(url)
            response = getJson(builder)

            request.result = {content: parseChannelResponse(response)}
        end sub

        getEmail: sub(request)
            port = CreateObject("roMessagePort")
            channelStore = CreateObject("roChannelStore")
            channelStore.SetMessagePort(port)

            emailData = channelStore.GetPartialUserData("email")
            request.result = {email: emailData.email}
        end sub


				'fetch activation code API
				fetchActivationCode: sub(request as Object)
                params = request.params
				baseURL = params.baseURL
				token = params.token
                info = CreateObject("roDeviceInfo")
				deviceId = info.GetChannelClientId()
				url = baseURL + m.GENERATE_CODE +"/" +token
				builder = RequestBuilder(url)
								ret = getJson(builder)
								if ret <> invalid and ret.DoesExist("code")
                   code = ret.code
								   request.result = {status: "success", code: code}
								else
										request.result = {status: "failed"}
								End If
				end sub
		
		   checkIsActivated: sub(request as Object)
		       params = request.params
               baseURL = params.baseURL
               email = params.email
               url = baseURL + m.IS_ACTIVATED + m.SLASH + email + m.SLASH +  m.API_KEY
               builder = RequestBuilder(url)
                ret = getJson(builder)
                if ret <> invalid
                request.result = {status: ret.isActivated}
                end if
           end sub
           
           
           isRegistered: sub(request as Object)
               params = request.params
               baseURL = params.baseURL
               email = params.email
               url = baseURL + m.IS_REGISTERED + m.SLASH + email + m.SLASH +  m.API_KEY
               builder = RequestBuilder(url)
                ret = getJson(builder)
                if ret <> invalid
                request.result = {isRegistered: ret.isRegistered, isActivated: ret.isActivated}
                end if
           end sub
           
				'API get subscription status
		    checkSubscription: sub(request as Object)
		       params = request.params
	           baseURL = params.baseURL
               token = params.token
	            url = baseURL + m.IS_ACTIVATED + m.SLASH + token + m.SLASH +  m.API_KEY
	            builder = RequestBuilder(url)
	            ret = getJson(builder)
	            print ret
	            if ret <> invalid
			            if ret["error"] <> Invalid  Then
			                request.result = {"status": false}
			            Else if ret["isActivated"] <> Invalid
			                request.result = {status:  ret["isActivated"]}
			            Else
			                request.result = {status: false}
			            End If
							else
							    request.result = {status: false}		
							end if
		    end sub
		    
		    

	}
end function

function parseChannelResponse(response) as Object
    content = createObject("roSGNode", "VideoNode")
    videoNode.setFields(response)

    return videoNode
end function

function parseSearchResponse(response) as Object
      content = createObject("roSGNode", "ContentNode")
      for each result in response.items
        videoNode = content.createChild("VideoNode")
        videoNode.setFields(result)
      end for

      return content
end function

function parseManageLists(response as Object) as Object
    content = createObject("roSGNode", "ContentNode")
    for each list in response.lists
        itemcontent = content.createChild("ListNode")
        itemcontent.title = list.list_name
        itemcontent.label = list.list_name
        itemcontent.id = list.list_id
        itemcontent.url = list.list_url
    end for

    return {content: content}
end function

function parseHomeContent(response as Object) as Object

   contentList = []
   tmpCatArr = []
   content = createObject("roSGNode", "ContentNode")
   displayMode = response.display_mode
   if (displayMode = invalid)
        displayMode = "list"
   end if

    if response <> Invalid then
        if response <> Invalid and response.count() > 0 and response.list <> Invalid and response.list.count() > 0 then
            for each item in response.list
                tmpCatArr.push(item.id)
            end for

            for i = 0 to tmpCatArr.count() - 1
                for each item in response.list
                    if tmpCatArr[i] = item.id then
                        cItm = item
                        itemcontent = content.createChild("HomeListContentNode")
                        gItem = {}
                        if cItm.poster <> Invalid and (cItm.poster).trim() <> "" then
                            gItem["hdgridposterurl"] = cItm.poster
                        end if
                        if cItm.name <> Invalid and (cItm.name).trim() <> "" then
                            gItem["shortdescriptionline1"] = cItm.name
                        end if
                        gItem["id"] = item.id
                        gItem["counter"] = cItm.counter

                        cItm["categoryId"] = item
                        itemcontent.setFields(gItem)
                        contentList.push(cItm)
                    end if
                end for
            end for
        end if
    end if

    return {
        content: content
        categoryList: contentList
        config:{
            display_mode: displayMode
        }
    }
end function

function getVideoContents(response as Object) as Object
   videoList = []
   content = createObject("roSGNode", "ContentNode")

   if response <> Invalid then
        if response <> Invalid and response.count() > 0 then
            for each item in response
                cItm = response[item]
                for j = 0 to cItm.count() - 1
                    vItm = cItm[j]
                    itemcontent = content.createChild("VideoNode")
                    if vItm.logo <> Invalid and (vItm.logo).trim() <> "" then
                         vItm["HDLISTITEMICONURL"] =  vItm.logo
                         vItm["HDLISTITEMICONSELECTEDURL"] =  vItm.logo
                    end if
                    itemcontent.setFields(vItm)
                    videoList.push(vItm)
                end for
            end for
        end if
    end if

    return {
        content: content
        videoItems: videoList
    }
end function

function getConfig(url as String) as Object
   info = CreateObject("roDeviceInfo")
   deviceId = info.GetChannelClientId()

   builder = RequestBuilder(url)
   return getJson(builder)
end function


function isSubcribed() as String

print "is subscribed"

end function 

' Mockup for API returning Terms Of Use text. Actual API call for getting Terms Of Use should be implemented here.
' Note: Terms Of Use should be returned as plain text without any HTML tags.
function getTermsOfUse() as String
    result = ""
    result = result + "SageIPTV requires a lifetime activation fee of $24.99 USD. "
    result = result + "From the info tab, click the subscribe button and follow the steps on your screen. "
    result = result + " This activation allows you to import and manage unlimited playlists."
    result = result + " Please let us know if you have any questions or issues with the installation. " 
    result = result + " SageIPTV knows that you care how information about you is used and shared, and we appreciate your trust that we will do so carefully and sensibly."
    result = result + " To know more about our privacy policy, please visit https://www.sageiptv.co/privacy-policy."
    result = result + Chr(10) + Chr(10)

return result
end function
