function RequestBuilder(url as String, port = invalid as Object, method = "GET" as String) as Object
    xfer = CreateObject("roURLTransfer")
    if port <> invalid then
        xfer.SetMessagePort(CreateObject("roMessagePort"))
    end if
    xfer.SetCertificatesFile("common:/certs/ca-bundle.crt")
    xfer.EnableEncodings(true)
    xfer.RetainBodyOnError(true)
    xfer.InitClientCertificates()
    xfer.SetURL(url)
    xfer.SetRequest(method)
    return xfer
end function